--v6 - добавил проверку на высадку над водой, двойное радиоменю
--v8 - добавлены сообщения о невозможности высадки
--v9 - теперь только одна группа помещается в вертушку, в будущем для погрузке по массе следует использовать v8
local _radius_cargo = 300;
local _heigtUncargo = 7;
local _speedUncargo = 20;

local _savePrice = 130; --увеличение флага при спасении
local _fall_time = 120; --время спуска на парашюте
local _FARP_serch_time = 50; -- время на выгрузку 

local _radius_FARP_serch = 500;
local _soundFileName = "l10n/DEFAULT/sos-tihiy.ogg";
local _ejectTransportList = {[1] = 'Mi-8MT', [2] = 'UH-1H', [3] = 'UAZ-469', [4]='BRDM-2', [5]='M1043 HMMWV Armament'}; --не удалять, транспорт лист катапультанта!

switcher_flag_eject = {	
	["off_ejecting"] = '570', --если 1 то катапультант отключен
	["radioblue_243"] = '571' --если 1 то у синих тоже 121,5МГц
};

counter_save_pilots_flags = {
	["red_local_res"] = '710',
	["blue_local_res"] = '720',
	["red_global_res"] = '711',
	["blue_global_res"] = '721'

};

if not trigger.misc.getUserFlag (switcher_flag_eject.off_ejecting) then trigger.action.setUserFlag (switcher_flag_eject.off_ejecting, 0); end
if not trigger.misc.getUserFlag (switcher_flag_eject.radioblue_243) then trigger.action.setUserFlag (switcher_flag_eject.radioblue_243, 0); end
if not trigger.misc.getUserFlag (counter_save_pilots_flags.red_global_res) then trigger.action.setUserFlag (counter_save_pilots_flags.red_global_res, 0); end
if not trigger.misc.getUserFlag (counter_save_pilots_flags.blue_global_res) then trigger.action.setUserFlag (counter_save_pilots_flags.blue_global_res, 0); end
if not trigger.misc.getUserFlag (counter_save_pilots_flags.red_local_res) then trigger.action.setUserFlag (counter_save_pilots_flags.red_local_res, 0); end
if not trigger.misc.getUserFlag (counter_save_pilots_flags.blue_local_res) then trigger.action.setUserFlag (counter_save_pilots_flags.blue_local_res, 0); end

--собираем инфу по десанту
local _tempDesantsGroup = {};
local _transportsCargo = {};
local _uncargoGroup = {};
local _existDesantMenu = {};
local _transportData = {};


function uncargoDesant(data)
--		env.info('Команда на выгрузку'..data.transport, false);
		local _transportUnit = Unit.getByName(data.transport);
		local _transportPoint = _transportUnit:getPoint();
		local _transportSide = _transportUnit:getCoalition();
		local _transportHeigt = _transportPoint.y - land.getHeight({x = _transportPoint.x, y = _transportPoint.z});
			
		local _transportVelocity = _transportUnit:getVelocity();
		local _transportSpeed = (math.sqrt((_transportVelocity.x^2) + (_transportVelocity.y^2) + (_transportVelocity.z^2)))*3.6;
		
		local _landTypeUD = land.getSurfaceType({x = _transportPoint.x + 10, y = _transportPoint.z + 10});
		if _landTypeUD == 2 or _landTypeUD == 3 then --если вода
			trigger.action.outTextForGroup(data.transportGroupID, 'Невозможно высадить группу на воду!', 5);
--			env.info(data.transport..' desant under water', false);
			return;
		end
		
		
		if _transportHeigt > _heigtUncargo then 
			--trigger.action.outText('Снизтесь до приемлимой высоты!', 5);
			trigger.action.outTextForGroup(data.transportGroupID, 'Снизтесь до приемлимой высоты!', 5);	
			return;			
		end
		if _transportSpeed > _speedUncargo then 
			--trigger.action.outText('Погасите скорость!', 5);
			trigger.action.outTextForGroup(data.transportGroupID, 'Погасите скорость!', 5);	
			return;			
		end	
		if _transportsCargo[data.transport] then
					for _, _desTemp in ipairs(_tempDesantsGroup) do
--					env.info('Temp '.._desTemp.desantType..' Side '.._desTemp.side..' In transport '.._cargoDes.desantType..' side '.._transportSide, false);
						if _desTemp.desantType == _transportsCargo[data.transport].desantType and _desTemp.side == _transportSide then
									local _tempName;
									if _transportsCargo[data.transport].desantName ~= nil then
										_tempName =	tostring(_transportsCargo[data.transport].desantName);
									else
										_tempName = _desTemp.desantType..' '..string.format("%.0f",timer.getTime())..'_'.._desTemp.side; --string.format("%.0f",timer.getTime())
									end							
							
									local _insertGroupData = 
										{									
											["name"] = _tempName,
											["visible"] = _desTemp.data.visible,
											["taskSelected"] = _desTemp.data.taskSelected,		
											["groupId"] = 1,
											["hidden"] = _desTemp.data.hidden,
											["units"] = {}, 
											["x"] = _transportPoint.x + 10,
											["y"] = _transportPoint.z + 10,											
											["start_time"] = 0,
											["route"] = {points={}, spans = {}},
										}

										for _unitIndex, _groupUnit in ipairs(_desTemp.data.units) do 
												local unit = 
												{
													["type"] = _groupUnit.type,
													["name"] = 'Unit#'.._unitIndex..'_'.._insertGroupData.name,
													["unitId"] = _unitIndex,
													["heading"] = _groupUnit.heading,
													["playerCanDrive"] = _groupUnit.playerCanDrive,
													["skill"] = _groupUnit.skill,
													["x"] = _groupUnit.x + _transportPoint.x + 10,
													["y"] = _groupUnit.y + _transportPoint.z + 10,
													["transportable"] = _groupUnit.transportable
												};
												table.insert(_insertGroupData.units, unit); 
										end
										
										if _desTemp.data.route.points then
											for _pointIndex, _point in ipairs(_desTemp.data.route.points) do
													local _points = 
													{
													["alt"] = land.getHeight({x = _point.x + _transportPoint.x + 10, y = _point.y + _transportPoint.z + 10}),
													["type"] = _point.type,
													["name"] = _point.name,
													
													["speed"] = _point.speed,
													["x"] = _point.x  + _transportPoint.x + 10,
													["y"] = _point.y  + _transportPoint.z + 10,
													["formation_template"] = _point.formation_template,
													["action"] = _point.action
													}; 
													local  _spans = {x = _points.x, y = _points.y} ;   
													table.insert(_insertGroupData.route.points, _points);
													table.insert(_insertGroupData.route.spans, _spans);
											end
										end
										
										local _status, _error = pcall(function() 
												coalition.addGroup(_desTemp.countryId, Group.Category.GROUND, _insertGroupData); 
											return 0;
											end);
										if not _status then
											trigger.action.outTextForGroup(data.transportGroupID, 'Невозможно высадить группу, попробуйте в другом месте!', 5);
--											env.error('Script not insert group', false);
										else
											_transportsCargo[data.transport] = nil;
											local _forUpCargo = {desantName = _insertGroupData.name, desantType = _desTemp.desantType, transportList = _desTemp.transportList};
											table.insert(_uncargoGroup, _forUpCargo);
											
											
											--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Выгрузить десант'});												
											--missionCommands.addCommand('Связаться с пехотой', {'Десант', 'Транспорт '..data.transport}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});
											--trigger.action.outText('Десант высажен!', 5);
											missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Выгрузить десант'});
											missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
											missionCommands.addCommandForGroup(data.transportGroupID, 'Связаться с пехотой', {'Десант', 'Транспорт '..data.transport}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});
											trigger.action.outTextForGroup(data.transportGroupID, 'Десант высажен!', 5);
											--env.info('Десант высажен! '.._forUpCargo.desantName..' Type-'.._forUpCargo.desantType..'. Всего на земле '..#_uncargoGroup, false);
										end
										_tempName = nil;
										_insertGroupData = nil;
										return;	
			
						end
					end

		end
	return;	
end;

function cargoGroup(data)	
--		env.info('Команда на погрузку '..tostring(data.transport)..' '..tostring(data.desantType)..' '..tostring(data.desantName), false);
		if data.desantName ~= nil then
		
			local _statusDelRadCG, _resultDelRadCG = pcall(function() --попытка удаления радиомаяка
				local _radionameCG = 'Komar_'..data.desantName;
				trigger.action.stopRadioTransmission(_radionameCG);
				return 0;
			end);	
		
			local _statusCG, _resultCG = pcall(function() --удаление
				local _delCargoGroup = Group.getByName(data.desantName);
					_delCargoGroup:destroy();
					return 0;
				end);				
			if not _statusCG then
					env.error ('Not delete cargos group',false);			
			end
		end
		_transportsCargo[data.transport] = {desantType = data.desantType, desantName = data.desantName};
		--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
		--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'});
		--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Загрузить с ППБ'});
		missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
		missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'});
		missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Загрузить с ППБ'});

		for _uncargoGroupIndex, _uncargoGroupValue in ipairs(_uncargoGroup) do
			if data.desantName == _uncargoGroupValue.desantName then table.remove(_uncargoGroup, _uncargoGroupIndex); end
		end
		
		--missionCommands.addCommand('Выгрузить десант', {'Десант', 'Транспорт '..data.transport}, uncargoDesant, {transportGroupID = data.transportGroupID, transport = data.transport});
		--trigger.action.outText('Десант погружен!', 5);
		missionCommands.addCommandForGroup(data.transportGroupID, 'Выгрузить десант', {'Десант', 'Транспорт '..data.transport}, uncargoDesant, {transportGroupID = data.transportGroupID, transport = data.transport});
		trigger.action.outTextForGroup(data.transportGroupID, 'Десант погружен!', 5);
		return;		
end;

function cancelSearch(data)
	--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'});
	--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
	--missionCommands.addCommand('Связаться с пехотой', {'Десант', 'Транспорт '..data.transport}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});	
	missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'});
	missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
	missionCommands.addCommandForGroup(data.transportGroupID, 'Связаться с пехотой', {'Десант', 'Транспорт '..data.transport}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});
	return;
end;

function searchGroup(data)
		local _transportUnit = Unit.getByName(data.transport);
		local _transportPoint = _transportUnit:getPoint();
		local _transportSide = _transportUnit:getCoalition();
		local _transportTypeName = _transportUnit:getTypeName();
		local _transportHeigt = _transportPoint.y - land.getHeight({x = _transportPoint.x, y = _transportPoint.z});
		
		local _transportVelocity = _transportUnit:getVelocity();
		local _transportSpeed = (math.sqrt((_transportVelocity.x^2) + (_transportVelocity.y^2) + (_transportVelocity.z^2)))*3.6;
		
		if _transportHeigt > _heigtUncargo then 
			--trigger.action.outText('Снизтесь до приемлимой высоты!', 5);
			trigger.action.outTextForGroup(data.transportGroupID, 'Снизтесь до приемлимой высоты!', 5);	
			return;			
		end
		if _transportSpeed > _speedUncargo then 
			--trigger.action.outText('Погасите скорость!', 5);
			trigger.action.outTextForGroup(data.transportGroupID, 'Погасите скорость!', 5);		
			return;			
		end		
		
		local _tempSearchGroup = {};
		if #_uncargoGroup > 0 then
		
			--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
			--missionCommands.addSubMenu('Скомандовать погрузку группе:', {'Десант', 'Транспорт '..data.transport});
			missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Связаться с пехотой'});
			missionCommands.addSubMenuForGroup(data.transportGroupID, 'Скомандовать погрузку группе:', {'Десант', 'Транспорт '..data.transport});
			local _menuCounter = 0;
			local _volume = {
					id = world.VolumeType.SPHERE,
					params = {
						point = _transportPoint,
						radius = _radius_cargo
					}
				};				
			
				world.searchObjects(Object.Category.UNIT, _volume, 
				function( _object, _data) 
					local _objectGroup =  _object:getGroup();
					local _objectGroupName = _objectGroup:getName();
					local _objectCoalition = _object:getCoalition();
					local _obGrSwich = 0;
					for _, _groupInTemp in ipairs(_tempSearchGroup) do
						if _groupInTemp == _objectGroupName then 
							_obGrSwich = 1;
							break;
						end				
					end
					if _obGrSwich == 0 then 
						for _, _uncargoGroupValue in ipairs(_uncargoGroup) do
							if _uncargoGroupValue.desantName == _objectGroupName and _objectCoalition == _transportSide then
								for _, _transportListType in ipairs(_uncargoGroupValue.transportList) do
									if _transportListType == _transportTypeName then
										table.insert(_tempSearchGroup, _objectGroupName);
										_menuCounter = _menuCounter + 1;
										--missionCommands.addCommand(  _objectGroupName, {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'}, cargoGroup, {transportGroupID = data.transportGroupID, transport = data.transport, desantType = _uncargoGroupValue.desantType, desantName = _objectGroupName});
										missionCommands.addCommandForGroup(data.transportGroupID, _objectGroupName, {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'}, cargoGroup, {transportGroupID = data.transportGroupID, transport = data.transport, desantType = _uncargoGroupValue.desantType, desantName = _objectGroupName});
										break;
									end
								end
							end
						end
					end
					_obGrSwich = 0;

					
					return true;
				end	, {});
			_tempSearchGroup = nil;
			if _menuCounter == 0 then 
				--missionCommands.removeItem({'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'});
				--missionCommands.addCommand('Связаться с пехотой', {'Десант', 'Транспорт '..data.transport}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});
				--trigger.action.outText('Нет групп для погрузки рядом', 5);
				missionCommands.removeItemForGroup(data.transportGroupID, {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'});
				missionCommands.addCommandForGroup(data.transportGroupID, 'Связаться с пехотой', {'Десант', 'Транспорт '..data.transport}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});
				trigger.action.outTextForGroup(data.transportGroupID, 'Нет групп для погрузки рядом', 5);
			else
					--missionCommands.addCommand('Отказ от погрузки', {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'}, cancelSearch, {transportGroupID = data.transportGroupID, transport = data.transport});
					missionCommands.addCommandForGroup(data.transportGroupID,'Отказ от погрузки', {'Десант', 'Транспорт '..data.transport, 'Скомандовать погрузку группе:'}, searchGroup, {transportGroupID = data.transportGroupID, transport = data.transport});
			end
		else
			--trigger.action.outText('Нет групп для погрузки', 5);
			trigger.action.outTextForGroup(data.transportGroupID, 'Нет групп для погрузки', 5);
			return;			
		end
		
		timer.scheduleFunction(function(_data) 
			local _timingTransportUnit = Unit.getByName(data.transport);
			local _timingTransportPoint = _timingTransportUnit:getPoint();
			local _timingTransportHeigt = _timingTransportPoint.y - land.getHeight({x = _timingTransportPoint.x, y = _timingTransportPoint.z});			
			local _timingTransportVelocity = _timingTransportUnit:getVelocity();
			local _timingTransportSpeed = (math.sqrt((_timingTransportVelocity.x^2) + (_timingTransportVelocity.y^2) + (_timingTransportVelocity.z^2)))*3.6;
			
			if _timingTransportHeigt > _heigtUncargo or  _timingTransportSpeed > _speedUncargo then 
				cancelSearch({transportGroupID = data.transportGroupID, transport = data.transport});
				env.info('Search is cancel', false);
				return;			
			end
			return timer.getTime() + 30; --время повторения поиска								
		end,{transportGroupID = data.transportGroupID, transport = data.transport}, timer.getTime() + 30); 

	return;
end



local customEventHandler = {};
function customEventHandler:onEvent(event)

	if world.event.S_EVENT_EJECTION == event.id and trigger.misc.getUserFlag (switcher_flag_eject.off_ejecting) == 0 then
	
		local _eject_object 		= event.initiator; 				--самолет с которого катапультировались
		local _eject_object_coal	= _eject_object:getCoalition(); --коалиция самолета
		local _eject_point 			= _eject_object:getPoint(); 	--координаты катапультирования
		
		local _pilotname	 = 'Pilot_ejecting_'..string.format("%.0f",timer.getTime()); 	--имя очередного катапультанта
		local _pilotUnitType; 						--тип наземного юнита
		local _pilotCountry; 						--страна наземного юнита
		local _radioFrec = '121500000'; --частота по умолчанию;
		
		local _landType = land.getSurfaceType({x = _eject_point.x + 10, y = _eject_point.z + 10});
		if _landType == 2 or _landType == 3 then --если вода
			env.info(_pilotname..' eject under water',false);
			return;
		end
		
		
		--устанавливаем страну и тип наземного юнита в соответствии с коалицией
		if coalition.side.RED == _eject_object_coal then
			_pilotUnitType	= 'Infantry AK';
			_pilotCountry 	= country.id.RUSSIA;
		elseif coalition.side.BLUE == _eject_object_coal then
			_pilotUnitType	= 'Soldier M4';
			_pilotCountry 	= country.id.USA;
			if trigger.misc.getUserFlag (switcher_flag_eject.radioblue_243) == 0 then _radioFrec = '243000000'; end
		end
--		local _radioname = 'Komar_'.._pilotname;

		local _insertGroupData = 
		{
			["visible"] = false,
			["taskSelected"] = true,
			["route"] = {points={}, spans = {}},
			["groupId"] = 1,
			["hidden"] = false,
			["units"] = {}, 
			["x"] = _eject_point.x + 10,
			["y"] = _eject_point.z + 10,
			["name"] = _pilotname,
			["start_time"] = 0,

		}
		local unit = 
			{
				["type"] = _pilotUnitType,
				["transportable"] = {["randomTransportable"] = true,},
				["unitId"] = 1,
				["skill"] = "Average",
				["x"] = _eject_point.x + 10,
				["y"] = _eject_point.z + 10,
				["name"] = _pilotname..'_unit ',
				["playerCanDrive"] = false,
				["heading"] = 0,
			};
		table.insert(_insertGroupData.units, unit); 


--[[		local _point = 
					{
						["alt"] = land.getHeight({x = _eject_point.x + 10, y = _eject_point.z + 10}),
						["type"] = "Turning Point",
						["ETA"] = 0,
						["alt_type"] = "BARO",
						["formation_template"] = "",
						["y"] = _eject_point.z + 10,
						["x"] = _eject_point.x + 10,
						["name"] = _pilotname..'_uncargoPoint',
						["ETA_locked"] = true,
						["speed"] = 5.5555555555556,
						["action"] = "Off Road",
						["speed_locked"] = true,
						["task"] = {}, -- end of ["task"]
					};


				table.insert(_insertGroupData.route.points, _point);--]]
				
--				local  _spans = {x = _eject_point.x + 10, y = _eject_point.z + 10} ;  
--				table.insert(_insertGroupData.route.spans, _spans); 

		timer.scheduleFunction(function()
		
								local _status, _result = pcall(function() --создание наземного объекта
									return coalition.addGroup(_pilotCountry, Group.Category.GROUND, _insertGroupData);	
								--	return 0;
								end);				
								if not _status then
									env.error ('Not create eject unit',false);
									return;
								end 
								
								local _forUpCargo = {desantName = _insertGroupData.name, desantType = 'Ejected', transportList = _ejectTransportList};
								table.insert(_uncargoGroup, _forUpCargo);
									
								_insertGroupData = nil;
								local _unit = Unit.getByName(_pilotname..'_unit ');
								timer.scheduleFunction(function(_data) --создаем автономную задачу поведения катапультанта
														
														if not (_data.unit and _data.unit:isExist()) then
																local _statusDelRad, _resultDelRad = pcall(function()
																	trigger.action.stopRadioTransmission(_radioname);
																	return 0;
																end);
																if not _statusDelRad then env.error ('Not delete radio',false);	end 
															return nil;
														end	--проверим, жив ли наш пилот, если мертв удаляем задачу
														
														--радиомаяк триггером	 --(аудиофайл, коорд. источника, ФМ/АМ, повтор, частота, мощность, название триггера)
														local _radioname = 'Komar_'.._pilotname;      --задаем название радиотриггеру
														
														local _pilot_point = _data.unit:getPoint();
														local _statusFl, _resultFl = pcall(function() --пуск сигналки
															return trigger.action.signalFlare(_pilot_point, trigger.flareColor.Red, 0);
														end);
															if not _statusFl then env.error ('Not create flare'.._radioname,false);	end 
														local _statusRad, _resultRad = pcall(function() --пуск сигналки	
															return trigger.action.radioTransmission(_soundFileName, _pilot_point, radio.modulation.AM, false, _radioFrec, 5, _radioname);
														end);
															if not _statusRad then env.error ('Not create radio'.._radioname,false); end 
														return timer.getTime() + 30; --время повторения поиска
								
								end,{unit = _unit}, timer.getTime() + 30); -- задержка выполнения (нужно прийти в себя после приземления)

			return;
		end,{} , timer.getTime()+_fall_time); --время полета до земли
	
	elseif world.event.S_EVENT_LAND == event.id then

			local _place = event.place;
			local _placeCat = _place:getTypeName();
			if _placeCat ~= 'FARP' then return; end
			local _placePoint = _place:getPoint();
			local _placeCoalition = _place:getCoalition();
			
			local _initName = event.initiator:getName();
			local _initType = event.initiator:getTypeName();
			local _initCoal = event.initiator:getCoalition();
		--[[	local _initGroup = event.initiator:getGroup();
			local _initGroupID = _initGroup:getID();
			local _initGroupName = _initGroup:getName();
			local _initGroupUnits = _initGroup:getUnits();--]]
			local _initGroupID = 0;
			for _, _traspData in ipairs(_transportData) do
	--			{unitNameDict = _groupTrName, unitName = _heli_unit.name, groupID = _heli_group.groupId};
				if _initName == _traspData.unitNameDict or _initName == _traspData.unitName then
					_initGroupID = _traspData.groupID;
					break;
				end		
			end
			if _initGroupID ~= 0 then 				
				--missionCommands.addSubMenu('Загрузить с ППБ', {'Десант', 'Транспорт '.._initName});
				missionCommands.addSubMenuForGroup(_initGroupID,'Загрузить с ППБ', {'Десант', 'Транспорт '.._initName});
				if #_tempDesantsGroup > 0 then
					for _, _desGroup in ipairs(_tempDesantsGroup) do
						if _placeCoalition == _initCoal and _initCoal == _desGroup.side and #_desGroup.transportList > 0 then
							for _, _desGroupTrasp in ipairs(_desGroup.transportList) do
								if _desGroupTrasp == _initType and _desGroup.desantType ~= 'Ejected' then
									--missionCommands.addCommand(_desGroup.desantType,{'Десант', 'Транспорт '.._initName, 'Загрузить с ППБ'}, cargoGroup, {transportGroupID = _initGroupID, transport = _initName, desantType = _desGroup.desantType, desantName = nil});
									missionCommands.addCommandForGroup(_initGroupID, _desGroup.desantType, {'Десант', 'Транспорт '.._initName, 'Загрузить с ППБ'}, cargoGroup, {transportGroupID = _initGroupID, transport = _initName, desantType = _desGroup.desantType, desantName = nil});
								end
							end
						end
					end
				end
			end
			
			timer.scheduleFunction(function()
				if trigger.misc.getUserFlag (switcher_flag_eject.off_ejecting) ~= 0 then return; end
				local _volume = {
					id = world.VolumeType.SPHERE,
					params = {
						point = _placePoint,
						radius = _radius_FARP_serch
					}
				};				
			
				world.searchObjects(Object.Category.UNIT, _volume, 
				function( _object, _data) 
					local _objectName =  _object:getName();
					local _ejectObj = string.find(_objectName, "ejecting");
					if _ejectObj ~= nil then						
						local _ejectPilotCoalition = _object:getCoalition();
						if _ejectPilotCoalition == _placeCoalition then
							if _ejectPilotCoalition == coalition.side.RED then 
								local _oldRedCount = trigger.misc.getUserFlag (counter_save_pilots_flags.red_global_res);
								trigger.action.setUserFlag (counter_save_pilots_flags.red_global_res, _oldRedCount + _savePrice);
								local _oldRedLocalCount = trigger.misc.getUserFlag (counter_save_pilots_flags.red_local_res);
								trigger.action.setUserFlag (counter_save_pilots_flags.red_local_res, _oldRedLocalCount + _savePrice);								
								trigger.action.outTextForCoalition(coalition.side.RED,'Пилот '.._objectName..' спасен!', 10, false);
							elseif _ejectPilotCoalition == coalition.side.BLUE then
								local _oldBlueCount = trigger.misc.getUserFlag (counter_save_pilots_flags.blue_global_res);
								trigger.action.setUserFlag (counter_save_pilots_flags.blue_global_res, _oldBlueCount + _savePrice);
								local _oldBlueLocalCount = trigger.misc.getUserFlag (counter_save_pilots_flags.blue_local_res);
								trigger.action.setUserFlag (counter_save_pilots_flags.blue_local_res, _oldBlueLocalCount + _savePrice);								
								trigger.action.outTextForCoalition(coalition.side.BLUE,'Пилот '.._objectName..' спасен!', 10, false);
							end
						end
						
						local _statusDel, _resultDel = pcall(function() --создание наземного объекта
							local _ejectGroup = _object:getGroup();
							_ejectGroup:destroy();
							return 0;
						end);
						if not _statusDel then env.error ('Not delete eject unit from FARP',false); end 

					end
					return true;
				end	, {});			

				return;
			end,{} , timer.getTime()+_FARP_serch_time); --время необходимое на выгрузку
	
	
	elseif world.event.S_EVENT_TAKEOFF == event.id then
			local _initName = event.initiator:getName();
			
			
		local _initGroupID = 0;
		for _, _traspData in ipairs(_transportData) do
--			{unitNameDict = _groupTrName, unitName = _heli_unit.name, groupID = _heli_group.groupId};
			if _initName == _traspData.unitNameDict or _initName == _traspData.unitName then
				_initGroupID = _traspData.groupID;
				break;
			end		
		end
		if _initGroupID ~= 0 then  
	--		local _initGroup = event.initiator:getGroup();
	--		local _initGroupID = _initGroup:getID();
	
	
	
			--missionCommands.removeItem({'Десант', 'Транспорт '.._initName, 'Загрузить с ППБ'});
			missionCommands.removeItemForGroup(_initGroupID, {'Десант', 'Транспорт '.._initName, 'Загрузить с ППБ'});				
		end
	elseif world.event.S_EVENT_CRASH == event.id or world.event.S_EVENT_DEAD == event.id then
		--		local _initGroup = event.initiator:getGroup();
		--		local _initGroupID = _initGroup:getID();
		local _statusCoD, _unit_properties = pcall(function() return { 
			name = event.initiator:getName(), category = event.initiator:getCategory(); } end);
			
		if not _statusCoD or (_unit_properties.category ~= 1) then 
--			env.warning('Не удается получить данные уничтоженного юнита или это не вертолет', false);
		else	
			local _initGroupID = 0;
			for _, _traspData in ipairs(_transportData) do
	--			{unitNameDict = _groupTrName, unitName = _heli_unit.name, groupID = _heli_group.groupId};
				if _unit_properties.name == _traspData.unitNameDict or _unit_properties.name == _traspData.unitName then
					_initGroupID = _traspData.groupID;
					break;
				end		
			end
			if _initGroupID ~= 0 then  



				
				--missionCommands.removeItem({'Десант', 'Транспорт '.._unit_properties.name, 'Загрузить с ППБ'});
				--missionCommands.removeItem({'Десант', 'Транспорт '.._unit_properties.name, 'Скомандовать погрузку группе:'});
				--missionCommands.removeItem({'Десант', 'Транспорт '.._unit_properties.name, 'Связаться с пехотой'});
				--missionCommands.addCommand('Связаться с пехотой', {'Десант', 'Транспорт '.._unit_properties.name}, searchGroup, {transportGroupID = _initGroupID, transport = _unit_properties.name});
						
				missionCommands.removeItemForGroup(_initGroupID, {'Десант', 'Транспорт '.._unit_properties.name, 'Загрузить с ППБ'});
				missionCommands.removeItemForGroup(_initGroupID, {'Десант', 'Транспорт '.._unit_properties.name, 'Скомандовать погрузку группе:'});
				missionCommands.removeItemForGroup(_initGroupID, {'Десант', 'Транспорт '.._unit_properties.name, 'Связаться с пехотой'});
				
				missionCommands.addCommandForGroup(_initGroupID, 'Связаться с пехотой', {'Десант', 'Транспорт '.._unit_properties.name}, searchGroup, {transportGroupID = _initGroupID, transport = _unit_properties.name});
				
				if _transportsCargo[_unit_properties.name] then
					_transportsCargo[_unit_properties.name] = nil; 
					missionCommands.removeItemForGroup(_initGroupID, {'Десант', 'Транспорт '.._unit_properties.name, 'Выгрузить десант'});
				end
				
			end
		end
	end
end;

world.addEventHandler(customEventHandler);


for _coalition_index, _coalition in pairs(env.mission.coalition) do 

	
	for _country_index, _country in ipairs(_coalition.country) do		
		if _country.helicopter and _country.helicopter.group then
			for _heli_group_index, _heli_group in ipairs(_country.helicopter.group) do
				if _heli_group.task == "Transport" then
					--missionCommands.addSubMenu('Десант');
					missionCommands.addSubMenuForGroup(_heli_group.groupId, 'Десант');
					for _heli_unit_index, _heli_unit in ipairs(_heli_group.units) do
						local _groupTrName = env.getValueDictByKey(_heli_unit.name);
						--missionCommands.addSubMenu('Транспорт '.._groupTrName, {'Десант'});
						--missionCommands.addCommand('Связаться с пехотой', {'Десант', 'Транспорт '.._groupTrName}, searchGroup, {transportGroupID = _heli_group.groupId, transport = _groupTrName});						
						missionCommands.addSubMenuForGroup(_heli_group.groupId, 'Транспорт '.._groupTrName, {'Десант'});
						missionCommands.addCommandForGroup(_heli_group.groupId, 'Связаться с пехотой', {'Десант', 'Транспорт '.._groupTrName}, searchGroup, {transportGroupID = _heli_group.groupId, transport = _groupTrName});
						local _tempTransportData = {unitNameDict = _groupTrName, unitName = _heli_unit.name, groupID = _heli_group.groupId};
						table.insert(_transportData, _tempTransportData);
						
					end
				end
			end
		end

		if _country.vehicle and _country.vehicle.group then 
			for _coalition_groups_index, _coalition_groups in ipairs(_country.vehicle.group) do
				local _groupName = env.getValueDictByKey(_coalition_groups.name);
				local _templateSwich = string.find(_groupName, "Desant");
				if not _templateSwich then _templateSwich = string.find(_groupName, "desant"); end
				

				if _templateSwich ~= nil and _coalition_groups.units then 
					local _DCSWgroup = Group.getByName(_groupName); 
					local _sideDCSWG = _DCSWgroup:getCoalition();					
					local _groupData = _coalition_groups;
					
					_groupData.groupId = 1;
					for _pointIndex, _point in ipairs(_groupData.route.points) do 
						_point.x = _point.x - _groupData.x;
						_point.y = _point.y - _groupData.y;
						_point.alt = 0;	
					end					
					for _, _groupUnit in ipairs(_coalition_groups.units) do					
						_groupUnit.x = _groupUnit.x - _groupData.x;
						_groupUnit.y = _groupUnit.y - _groupData.y;						
					end
					_groupData.x, _groupData.y = 0, 0;
--					_groupData.name = 'Desant';	
					local _transportList = {};
					for _, _task in ipairs(_groupData.tasks) do 
						if _task.id == 'EmbarkToTransport' and _task.name then
							table.insert (_transportList, _task.name); 							
						end
					end
					local _groupType = string.sub(_groupName, 0,_templateSwich - 2);	
					_groupType = _groupType..string.sub(_groupName, _templateSwich +6);	
					local _groupForTable = {desantType = _groupType, side = _sideDCSWG, countryId = _country.id, data = _groupData, transportList = _transportList};

					table.insert (_tempDesantsGroup, _groupForTable); 					
					
					_DCSWgroup:destroy();
				end
				_templateSwich = nil, nil;
			end
		end
	end

	local _ejectGroupType = '';
	local _ejectUnitType;
	local _ejectCountry;
	local _ejectType;	
	if _coalition.name == 'blue' or _coalition.name == 'BLUE' then
		_ejectUnitType	= 'Soldier M4';
		_ejectCountry 	= country.id.USA;
		_ejectSide = coalition.side.BLUE;
		_ejectGroupType = 'Ejected';
	elseif _coalition.name == 'red' or _coalition.name == 'RED' then
		_ejectUnitType	= 'Infantry AK';
		_ejectCountry 	= country.id.RUSSIA;
		_ejectSide = coalition.side.RED;
		_ejectGroupType = 'Ejected';
	end
	if _ejectGroupType == 'Ejected' then
		local _ejectGroupData = 
		{
			["visible"] = false,
			["taskSelected"] = true,
			["route"] = {points={}, spans = {}},
			["groupId"] = 1,
			["hidden"] = false,
			["units"] = {}, 
			["x"] = 0,
			["y"] = 0,
			["name"] = 'Default'.._ejectSide,
			["start_time"] = 0,

		}
		local unit = 
			{
				["type"] = _ejectUnitType,
				["transportable"] = {["randomTransportable"] = true,},
				["unitId"] = 1,
				["skill"] = "Average",
				["x"] = 0,
				["y"] = 0,
				["name"] = 'Default_unit_'.._ejectSide,
				["playerCanDrive"] = false,
				["heading"] = 0,
			};
		table.insert(_ejectGroupData.units, unit); 


--[[			local _point = 
					{
						["alt"] = 0,
						["type"] = "Turning Point",
						["ETA"] = 0,
						["alt_type"] = "BARO",
						["formation_template"] = "",
						["y"] = 0,
						["x"] = 0,
						["name"] =  'Default_unit_'.._ejectSide..'_uncargoPoint',
						["ETA_locked"] = true,
						["speed"] = 5.5555555555556,
						["action"] = "Off Road",
						["speed_locked"] = true,
						["task"] = {}, -- end of ["task"]
					};
		table.insert(_ejectGroupData.route.points, _point);--]]
		local _groupEjectForTable = {desantType = _ejectGroupType, side = _ejectSide, countryId = _ejectCountry, data = _ejectGroupData, transportList = _ejectTransportList};
		table.insert (_tempDesantsGroup, _groupEjectForTable); 	
	end
end;
--

--local _distance = math.sqrt( (_obj_point.x - _data.point.x)^2 + (_obj_point.z - _data.point.z)^2);
